package dtu.library.ui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import dtu.library.app.Book;
import dtu.library.app.LibraryApp;

public class LibraryUI {

	private Screen screen;;
	private LibraryApp libraryApp = new LibraryApp();
	private Book currentBook;

	public LibraryUI() {
		setScreen(new UserScreen());
	}

	public void printMenu(PrintWriter out) throws IOException {
		getScreen().printMenu(out);
	}

	public boolean processInput(String input, PrintWriter out) throws IOException {
		boolean exit = getScreen().processInput(input, out);
		out.println();
		return exit;
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out, true);
		LibraryUI ui = new LibraryUI();
		ui.basicLoop(in, out);
	}

	public void basicLoop(BufferedReader in, PrintWriter out)
			throws IOException {
		String selection;
		do {
			printMenu(out);
			selection = readInput(in);
		} while (!processInput(selection, out));
	}

	void setScreen(Screen screen) {
		this.screen = screen;
		this.screen.setLibraryUI(this);
	}

	Screen getScreen() {
		return screen;
	}

	LibraryApp getLibraryApp() {
		return libraryApp;
	}

	void setCurrentBook(Book book) {
		currentBook = book;
	}

	Book getCurrentBook() {
		return currentBook;
	}

	public String readInput(BufferedReader in) throws IOException {
		return in.readLine();
	}
}
